module win32.tchar;
import win32.windef;
import win32.winbase;
import std.utf;

version(Unicode)
{
    TCHAR* _T( wchar[] str ) { return (str~\0).ptr; }

     char[] TtoC( TCHAR* tc ) { return TtoW(tc).toUTF8(); }
    wchar[] TtoW( TCHAR* tc ) { return tc[0..lstrlen(tc)]; }
}
else
{
    import std.windows.charset;
    TCHAR* _T( char[] str ) { return str.toMBSz(); }

     char[] TtoC( TCHAR* tc ) { return fromMBSz(tc); }
    wchar[] TtoW( TCHAR* tc ) { return fromMBSz(tc).toUTF16(); }
}
